'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Dropdown = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createRef = require('create-react-ref/lib/createRef');

var _createRef2 = _interopRequireDefault(_createRef);

var _withTheme = require('./HOC/withTheme');

var _themes = require('../utils/themes');

var _ = require('.');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// internal utility functions


// import constants


var DropdownBase = function (_Component) {
  _inherits(DropdownBase, _Component);

  // define static properties
  function DropdownBase(props) {
    _classCallCheck(this, DropdownBase);

    // define ref
    var _this = _possibleConstructorReturn(this, (DropdownBase.__proto__ || Object.getPrototypeOf(DropdownBase)).call(this, props));

    _this.toggleOpen = function () {
      _this.setState({ isOpen: !_this.state.isOpen });
    };

    _this._setMouseOverItems = function (isMouseOverItems) {
      _this.setState({ isMouseOverItems: isMouseOverItems });
    };

    _this._setMouseOverRoot = function (isMouseOverRoot) {
      _this.setState({ isMouseOverRoot: isMouseOverRoot });
    };

    _this._onItemSelected = function (item) {
      var onItemSelected = _this.props.onItemSelected;

      _this._setMouseOverRoot(false);
      _this._setMouseOverItems(false);
      _this.setState({ isOpen: false });
      if (onItemSelected) {
        onItemSelected(item);
      }
    };

    _this._onLabelClick = function () {
      _this.toggleOpen();
    };

    _this.rootElement = (0, _createRef2.default)();

    var context = props.context,
        themeId = props.themeId,
        theme = props.theme,
        themeOverrides = props.themeOverrides;

    _this.state = {
      composedTheme: (0, _themes.composeTheme)((0, _themes.addThemeId)(theme || context.theme, themeId), (0, _themes.addThemeId)(themeOverrides, themeId), context.ROOT_THEME_API),
      isOpen: false,
      isMouseOverItems: false,
      isMouseOverRoot: false
    };
    return _this;
  }
  // declare ref types


  _createClass(DropdownBase, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      (0, _themes.didThemePropsChange)(this.props, nextProps, this.setState.bind(this));
    }

    // ========= PUBLIC SKIN API =========

    // ========= PRIVATE SKIN API =========

  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          clickToOpen = _props.clickToOpen,
          context = _props.context,
          isOpen = _props.isOpen,
          onItemSelected = _props.onItemSelected,
          skin = _props.skin,
          theme = _props.theme,
          themeOverrides = _props.themeOverrides,
          rest = _objectWithoutProperties(_props, ['clickToOpen', 'context', 'isOpen', 'onItemSelected', 'skin', 'theme', 'themeOverrides']);

      var DropdownSkin = skin || context.skins[_.IDENTIFIERS.DROPDOWN];
      var _state = this.state,
          isMouseOverItems = _state.isMouseOverItems,
          isMouseOverRoot = _state.isMouseOverRoot;

      var isOpenBecauseOfHover = clickToOpen ? false : isMouseOverItems || isMouseOverRoot;

      return _react2.default.createElement(DropdownSkin, _extends({
        isOpen: isOpen || this.state.isOpen || isOpenBecauseOfHover,
        onLabelClick: this._onLabelClick,
        onItemSelected: this._onItemSelected,
        rootRef: this.rootElement,
        theme: this.state.composedTheme,
        setMouseOverRoot: this._setMouseOverRoot,
        setMouseOverItems: this._setMouseOverItems
      }, rest));
    }
  }]);

  return DropdownBase;
}(_react.Component);

DropdownBase.displayName = 'Dropdown';
DropdownBase.defaultProps = {
  context: (0, _withTheme.createEmptyContext)(),
  clickToOpen: false,
  noArrow: false,
  theme: null,
  themeOverrides: {},
  themeId: _.IDENTIFIERS.DROPDOWN
};
var Dropdown = exports.Dropdown = (0, _withTheme.withTheme)(DropdownBase);
//# sourceMappingURL=Dropdown.js.map