'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DropdownSkin = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Options = require('../../components/Options');

var _OptionsSkin = require('./OptionsSkin');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// components
var DropdownSkin = exports.DropdownSkin = function DropdownSkin(props) {
  var theme = props.theme,
      themeId = props.themeId,
      setMouseOverItems = props.setMouseOverItems,
      setMouseOverRoot = props.setMouseOverRoot;

  var themeApi = theme[themeId];
  return _react2.default.createElement(
    'div',
    {
      ref: props.rootRef,
      className: (0, _classnames2.default)([props.className, themeApi.dropdown]),
      onMouseEnter: function onMouseEnter() {
        return setMouseOverRoot(true);
      },
      onMouseLeave: function onMouseLeave() {
        return setMouseOverRoot(false);
      }
    },
    _react2.default.createElement(
      'div',
      {
        className: themeApi.label,
        onClick: props.onLabelClick
      },
      props.label
    ),
    _react2.default.createElement(_Options.Options, {
      skin: _OptionsSkin.OptionsSkin,
      theme: props.theme,
      isOpen: props.isOpen,
      options: props.items,
      onChange: props.onItemSelected,
      selectedOption: props.activeItem,
      setMouseIsOverOptions: setMouseOverItems,
      noOptionsArrow: props.noArrow,
      isFloating: true
    })
  );
};

// skins


// external libraries
//# sourceMappingURL=DropdownSkin.js.map