'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StepperSkin = undefined;

var _isFunction2 = require('lodash/isFunction');

var _isFunction3 = _interopRequireDefault(_isFunction2);

var _map2 = require('lodash/map');

var _map3 = _interopRequireDefault(_map2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var StepperSkin = exports.StepperSkin = function StepperSkin(props) {
  var label = void 0;
  if (!props.steps) return null;

  if (!props.labelDisabled) {
    var calculatedLabel = props.activeStep && 'STEP ' + props.activeStep + ' OF ' + props.steps.length;
    label = props.label ? props.label : calculatedLabel;
  }

  return _react2.default.createElement(
    'div',
    {
      role: 'presentation',
      'aria-hidden': true,
      className: (0, _classnames2.default)([props.className, props.theme[props.themeId].root])
    },
    _react2.default.createElement(
      'div',
      { className: props.theme[props.themeId].wrapper },
      label && _react2.default.createElement(
        'div',
        {
          className: props.theme[props.themeId].label
        },
        _react2.default.createElement(
          'h3',
          null,
          label
        )
      ),
      _react2.default.createElement(
        'ul',
        { className: props.theme[props.themeId].stepsWrapper },
        (0, _map3.default)(props.steps, function (step, index) {
          var classname = void 0;
          if (index + 1 < props.activeStep) {
            classname = 'finished';
          } else if (index + 1 === props.activeStep) {
            classname = 'active';
          } else {
            classname = 'disabled';
          }

          var handleStepClick = function handleStepClick(event) {
            if (props.onStepClick && (0, _isFunction3.default)(props.onStepClick)) {
              props.onStepClick(step, index, event);
            }
          };

          return _react2.default.createElement(
            'li',
            {
              key: index,
              className: props.theme[props.themeId][classname],
              style: { width: 100 / props.steps.length + '%' },
              role: 'presentation',
              'aria-hidden': true,
              onClick: handleStepClick
            },
            step
          );
        })
      )
    )
  );
};

// external libraries

// $FlowFixMe
//# sourceMappingURL=StepperSkin.js.map